Ameba::Rule::Performance::AnyAfterFilter - ameba 1.6.4-1-dev

# class Ameba::Rule::Performance::AnyAfterFilter

- Ameba::Rule::Performance::AnyAfterFilter
- Ameba::Rule::Performance::Base
- Ameba::Rule::Base
- Reference
- Object

##
Overview

This rule is used to identify usage of `any?` calls that follow filters.

For example, this is considered invalid:

    [1, 2, 3].select { |e| e > 2 }.any?
    [1, 2, 3].reject { |e| e >= 2 }.any?

And it should be written as this:

    [1, 2, 3].any? { |e| e > 2 }
    [1, 2, 3].any? { |e| e < 2 }

YAML configuration example:

    Performance/AnyAfterFilter:
      Enabled: true
      FilterNames:
        - select
        - reject

##
Included Modules

- Ameba::AST::Util
- YAML::Serializable
- YAML::Serializable::Strict

##
Defined in:

ameba/rule/performance/any_after_filter.cr

##
Constant Summary

MSG = `"Use `any? {...}` instead of `%s {...}.any?`"`

##
Constructors

- .new(ctx : YAML::ParseContext, node : YAML::Nodes::Node)

  This rule is used to identify usage of `any?` calls that follow filters.

- .new(config = nil)

  This rule is used to identify usage of `any?` calls that follow filters.

- .new(*, __context_for_yaml_serializable ctx : YAML::ParseContext, __node_for_yaml_serializable node : YAML::Nodes::Node)

##
Class Method Summary

- .parsed_doc : String | Nil

  Returns documentation for this rule, if there is any.

##
Instance Method Summary

- #description : String
- #description=(description : String)
- #enabled=(enabled : Bool)
- #enabled? : Bool
- #excluded : Array(String) | Nil
- #excluded=(excluded : Array(String) | Nil)
- #filter_names : Array(String)
- #filter_names=(filter_names : Array(String))
- #severity : Ameba::Severity
- #severity=(severity : Ameba::Severity)
- #test(source, node : Crystal::Call)

### Instance methods inherited from module `Ameba::AST::Util`

abort?(node) abort?, control_exp_code(node : Crystal::ControlExpression, code_lines) control_exp_code, dynamic_literal?(node) : Bool dynamic_literal?, exit?(node) exit?, flow_command?(node, in_loop) flow_command?, flow_expression?(node, in_loop = false) flow_expression?, literal?(node) : Bool literal?, loop?(node) loop?, name_end_location(node) name_end_location, name_location(node) name_location, name_size(node) name_size, node_source(node, code_lines) node_source, path_named?(node, name) : Bool path_named?, raise?(node) raise?, source_between(loc, end_loc, code_lines) : String | Nil source_between, static_literal?(node) : Bool static_literal?

### Instance methods inherited from class `Ameba::Rule::Performance::Base`

catch(source : Source) catch

### Constructor methods inherited from class `Ameba::Rule::Performance::Base`

new(ctx : YAML::ParseContext, node : YAML::Nodes::Node)
new(config = nil)
new(*, __context_for_yaml_serializable ctx : YAML::ParseContext, __node_for_yaml_serializable node : YAML::Nodes::Node) new

### Class methods inherited from class `Ameba::Rule::Performance::Base`

parsed_doc : String | Nil parsed_doc

### Instance methods inherited from class `Ameba::Rule::Base`

==(other) ==, catch(source : Source) catch, excluded?(source) excluded?, group group, hash hash, name name, special? special?, test(source : Source, node : Crystal::ASTNode, *opts)
test(source : Source) test

### Class methods inherited from class `Ameba::Rule::Base`

default_severity : Ameba::Severity default_severity

### Macros inherited from class `Ameba::Rule::Base`

issue_for(*args, **kwargs, &block) issue_for

### Macros inherited from module `Ameba::Config::RuleConfig`

properties(&block) properties

##
Constructor Detail

def self.new(ctx : YAML::ParseContext, node : YAML::Nodes::Node) #

This rule is used to identify usage of `any?` calls that follow filters.

For example, this is considered invalid:

    [1, 2, 3].select { |e| e > 2 }.any?
    [1, 2, 3].reject { |e| e >= 2 }.any?

And it should be written as this:

    [1, 2, 3].any? { |e| e > 2 }
    [1, 2, 3].any? { |e| e < 2 }

YAML configuration example:

    Performance/AnyAfterFilter:
      Enabled: true
      FilterNames:
        - select
        - reject

def self.new(config = nil) #

This rule is used to identify usage of `any?` calls that follow filters.

For example, this is considered invalid:

    [1, 2, 3].select { |e| e > 2 }.any?
    [1, 2, 3].reject { |e| e >= 2 }.any?

And it should be written as this:

    [1, 2, 3].any? { |e| e > 2 }
    [1, 2, 3].any? { |e| e < 2 }

YAML configuration example:

    Performance/AnyAfterFilter:
      Enabled: true
      FilterNames:
        - select
        - reject

def self.new(*, __context_for_yaml_serializable ctx : YAML::ParseContext, __node_for_yaml_serializable node : YAML::Nodes::Node) #

##
Class Method Detail

def self.parsed_doc : String | Nil #

Returns documentation for this rule, if there is any.

    module Ameba
      # This is a test rule.
      # Does nothing.
      class MyRule < Ameba::Rule::Base
        def test(source)
        end
      end
    end

    MyRule.parsed_doc # => "This is a test rule.\nDoes nothing."

##
Instance Method Detail

def description : String #
def description=(description : String) #
def enabled=(enabled : Bool) #
def enabled? : Bool #
def excluded : Array(String) | Nil #
def excluded=(excluded : Array(String) | Nil) #
def filter_names : Array(String) #
def filter_names=(filter_names : Array(String)) #
def severity : Ameba::Severity #
def severity=(severity : Ameba::Severity) #
def test(source, node : Crystal::Call) #